USE master
GO

CREATE LOGIN Alex WITH PASSWORD = '1234567890' MUST_CHANGE, CHECK_EXPIRATION=ON;
CREATE LOGIN Nick WITH PASSWORD = '1234567890' MUST_CHANGE, CHECK_EXPIRATION=ON;
CREATE LOGIN Lora WITH PASSWORD = '1234567890' MUST_CHANGE, CHECK_EXPIRATION=ON;
GO

CREATE USER Alex FOR LOGIN Alex;
CREATE USER Nick FOR LOGIN Nick;
CREATE USER Lora FOR LOGIN Lora;
GO

USE Test2
GO

CREATE USER Alex FOR LOGIN Alex WITH DEFAULT_SCHEMA=dbo69;
CREATE USER Nick FOR LOGIN Nick WITH DEFAULT_SCHEMA=dbo69;
CREATE USER Lora FOR LOGIN Lora WITH DEFAULT_SCHEMA=dbo69;
GO

GRANT CREATE TABLE ON DATABASE::Test2 TO Alex
GRANT CREATE TABLE ON DATABASE::Test2 TO Nick
GRANT CREATE TABLE ON DATABASE::Test2 TO Lora
GO

CREATE ROLE Alex_Team;
GO

ALTER ROLE Alex_Team ADD MEMBER Nick;
ALTER ROLE Alex_Team ADD MEMBER Lora;
GO

GRANT CONTROL ON ROLE::Alex_Team TO Alex;

GRANT CONTROL ON USER::Nick TO Alex;
GRANT CONTROL ON USER::Lora TO Alex;
GO

CREATE SCHEMA dbo69;
GO

GRANT CONTROL ON SCHEMA::dbo69 TO Alex
GO
GRANT SELECT, INSERT, UPDATE, DELETE, EXECUTE, VIEW DEFINITION ON SCHEMA::dbo69 TO Alex_Team
GO

CREATE TABLE dbo69.EventHandlers (
      ID int IDENTITY(1,1) NOT NULL
    , TABLE_SCHEMA nvarchar(128) NOT NULL
    , TABLE_NAME nvarchar(128) NOT NULL
    , COLUMN_NAME nvarchar(128) NULL
    , EVENT_NAME varchar(50) NOT NULL
    , HANDLER_SCHEMA nvarchar(128) NULL
    , HANDLER_NAME nvarchar(128) NULL
    , HANDLER_TYPE nvarchar(128) NULL
    , HANDLER_CODE nvarchar(MAX) NULL
    , TARGET_WORKSHEET nvarchar(128) NULL
    , MENU_ORDER int NULL
    , EDIT_PARAMETERS bit NULL
    , IS_ACTIVE bit NULL DEFAULT((1))
    , CONSTRAINT PK_EventHandlers_dbo69 PRIMARY KEY (ID)
);
GO

CREATE TABLE dbo69.TableFormats (
      ID int IDENTITY(1,1) NOT NULL
    , TABLE_SCHEMA nvarchar(128) NOT NULL
    , TABLE_NAME nvarchar(128) NOT NULL
    , TABLE_EXCEL_FORMAT_XML xml NULL
    , CONSTRAINT PK_TableFormat_dbo69 PRIMARY KEY (ID)
    , CONSTRAINT IX_TableFormats_Schema_Name_dbo69 UNIQUE (TABLE_NAME, TABLE_SCHEMA)
);
GO

INSERT INTO dbo69.EventHandlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE) VALUES ('dbo69', 'EventHandlers', 'EVENT_NAME', 'ValidationList', NULL, NULL, 'VALUES', 'Actions,Change,ContextMenu,DoubleClick,SelectionChange,ConvertFormulas,DoNotConvertFormulas,DoNotSelect,DoNotSave,DoNotChange,ProtectRows,Formula,FormulaValue,ValidationList,SelectionList');

INSERT INTO dbo69.EventHandlers (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE) VALUES ('dbo69', 'EventHandlers', 'HANDLER_TYPE', 'ValidationList', NULL, NULL, 'VALUES', 'TABLE,VIEW,PROCEDURE,FUNCTION,CODE,HTTP,TEXT,MACRO,CMD,VALUES,RANGE,REFRESH,MENUSEPARATOR');
GO
