-- =============================================
-- Application: Excel Applications. 11 Steps for Advanced Users
-- Developer:   Sergey Vaselenko
-- Release:     1.0, 2017-03-20
-- =============================================
GO

USE Test2
GO

CREATE TABLE [dbo69].[Payments] (
      [ID] int IDENTITY(1,1) NOT NULL
    , [Date] datetime NULL
    , [Sum] float NULL
    , [Account] nvarchar(255) NULL
    , [Company] nvarchar(255) NULL
    , [Item] nvarchar(255) NULL
    , [Comment] nvarchar(255) NULL
    , CONSTRAINT [PK_Payments_dbo69] PRIMARY KEY ([ID])
)
GO

CREATE TABLE [dbo69].[Companies] (
      [Company] nvarchar(255) NOT NULL
    , [LastModified] datetime NULL
    , [UserName] nvarchar(50) NULL
    , CONSTRAINT [PK_Companies_dbo69] PRIMARY KEY ([Company])
)
GO

SET IDENTITY_INSERT [dbo69].[Payments] ON;
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (1, '20170110 00:00:00.000', 200000, N'My Bank', N'Rose, Inc', N'Revenue');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (2, '20170110 00:00:00.000', -50000, N'My Bank', N'Land, Inc', N'Expenses');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Item]) VALUES (3, '20170131 00:00:00.000', -87000, N'My Bank', N'Payroll');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (4, '20170131 00:00:00.000', -13000, N'My Bank', N'Income Taxes', N'Taxes');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (5, '20170131 00:00:00.000', -29580, N'My Bank', N'Salary Taxes', N'Taxes');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (6, '20170210 00:00:00.000', 300000, N'My Bank', N'Rose, Inc', N'Revenue');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (7, '20170210 00:00:00.000', 100000, N'My Bank', N'Carnation, Inc', N'Revenue');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (8, '20170210 00:00:00.000', -50000, N'My Bank', N'Water, Inc', N'Expenses');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (9, '20170210 00:00:00.000', -100000, N'My Bank', N'Land, Inc', N'Expenses');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Item]) VALUES (10, '20170228 00:00:00.000', -87000, N'My Bank', N'Payroll');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (11, '20170228 00:00:00.000', -13000, N'My Bank', N'Income Taxes', N'Taxes');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (12, '20170228 00:00:00.000', -29580, N'My Bank', N'Salary Taxes', N'Taxes');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (13, '20170310 00:00:00.000', 300000, N'My Bank', N'Rose, Inc', N'Revenue');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (14, '20170310 00:00:00.000', 200000, N'My Bank', N'Carnation, Inc', N'Revenue');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (15, '20170310 00:00:00.000', 100000, N'My Bank', N'Cornflower, Corp', N'Revenue');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (16, '20170315 00:00:00.000', -36000, N'My Bank', N'Corporate Tax', N'Taxes');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Item]) VALUES (17, '20170331 00:00:00.000', -174000, N'My Bank', N'Payroll');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (18, '20170331 00:00:00.000', -26000, N'My Bank', N'Income Taxes', N'Taxes');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (19, '20170331 00:00:00.000', -59160, N'My Bank', N'Salary Taxes', N'Taxes');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (20, '20170331 00:00:00.000', -50000, N'My Bank', N'Water, Inc', N'Expenses');
INSERT INTO [dbo69].[Payments] ([ID], [Date], [Sum], [Account], [Company], [Item]) VALUES (21, '20170331 00:00:00.000', -100000, N'My Bank', N'Land, Inc', N'Expenses');
SET IDENTITY_INSERT [dbo69].[Payments] OFF;
GO

INSERT INTO [dbo69].[Companies] ([Company]) VALUES (N'Carnation, Inc');
INSERT INTO [dbo69].[Companies] ([Company]) VALUES (N'Cornflower, Corp');
INSERT INTO [dbo69].[Companies] ([Company]) VALUES (N'Corporate Tax');
INSERT INTO [dbo69].[Companies] ([Company]) VALUES (N'Income Taxes');
INSERT INTO [dbo69].[Companies] ([Company]) VALUES (N'Land, Inc');
INSERT INTO [dbo69].[Companies] ([Company]) VALUES (N'Rose, Inc');
INSERT INTO [dbo69].[Companies] ([Company]) VALUES (N'Salary Taxes');
INSERT INTO [dbo69].[Companies] ([Company]) VALUES (N'Water, Inc');
GO

INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [COLUMN_NAME], [EVENT_NAME], [HANDLER_SCHEMA], [HANDLER_NAME], [HANDLER_TYPE], [HANDLER_CODE], [IS_ACTIVE]) VALUES (N'dbo69', N'Payments', N'Account', N'ValidationList', N'dbo69', N'Accounts', N'VALUES', N'My Bank', 1);
INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [COLUMN_NAME], [EVENT_NAME], [HANDLER_SCHEMA], [HANDLER_NAME], [HANDLER_TYPE], [HANDLER_CODE], [IS_ACTIVE]) VALUES (N'dbo69', N'Payments', N'Item', N'ValidationList', N'dbo69', N'Items', N'VALUES', N'Revenue,Expenses,Payroll,Taxes', 1);
INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [COLUMN_NAME], [EVENT_NAME], [HANDLER_SCHEMA], [HANDLER_NAME], [HANDLER_TYPE], [HANDLER_CODE], [IS_ACTIVE]) VALUES (N'dbo69', N'Payments', N'Company', N'ValidationList', N'dbo69', N'Companies', N'TABLE', N'Company', 1);
INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [EVENT_NAME], [HANDLER_SCHEMA], [HANDLER_NAME], [HANDLER_TYPE], [TARGET_WORKSHEET], [IS_ACTIVE]) VALUES (N'dbo69', N'Payments', N'SelectionChange', N'dbo69', N'Payments', N'TABLE', N'_TaskPane _Transpose', 1);
INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [COLUMN_NAME], [EVENT_NAME], [HANDLER_SCHEMA], [HANDLER_NAME], [HANDLER_TYPE], [HANDLER_CODE], [IS_ACTIVE]) VALUES (N'dbo69', N'Payments', N'Company', N'ContextMenu', N'dbo69', N'Payments', N'TABLE', N'+Date,+Sum,Account,@Company,Item,Comment', 1);
INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [COLUMN_NAME], [EVENT_NAME], [HANDLER_SCHEMA], [HANDLER_NAME], [HANDLER_TYPE], [HANDLER_CODE], [IS_ACTIVE]) VALUES (N'dbo69', N'Payments', N'Item', N'ContextMenu', N'dbo69', N'Payments', N'TABLE', N'+Date,+Sum,Account,Company,@Item,Comment', 1);
INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [EVENT_NAME], [HANDLER_SCHEMA], [HANDLER_NAME], [HANDLER_TYPE], [HANDLER_CODE], [IS_ACTIVE]) VALUES (N'dbo69', N'EventHandlers', N'Actions', N'dbo69', N'Instruction', N'HTTP', N'https://www.savetodb.com/savetodb/configuring-event-handlers.htm', 1);
INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [COLUMN_NAME], [EVENT_NAME], [HANDLER_CODE], [IS_ACTIVE]) VALUES (N'dbo69', N'Companies', N'LastModified', N'FormulaValue', N'=NOW()', 1);
INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [COLUMN_NAME], [EVENT_NAME], [HANDLER_CODE], [IS_ACTIVE]) VALUES (N'dbo69', N'Companies', N'UserName', N'FormulaValue', N'=UserName()', 1);
INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [COLUMN_NAME], [EVENT_NAME], [IS_ACTIVE]) VALUES (N'dbo69', N'Companies', N'LastModified', N'DoNotChange', 1);
INSERT INTO [dbo69].[EventHandlers] ([TABLE_SCHEMA], [TABLE_NAME], [COLUMN_NAME], [EVENT_NAME], [IS_ACTIVE]) VALUES (N'dbo69', N'Companies', N'UserName', N'DoNotChange', 1);
GO

INSERT INTO [dbo69].[TableFormats] ([TABLE_SCHEMA], [TABLE_NAME], [TABLE_EXCEL_FORMAT_XML]) VALUES (N'dbo69', N'EventHandlers', '<table name="dbo69.EventHandlers"><columnFormats><column name="" property="ListObjectName" value="handlers_Table1" type="String"/><column name="" property="ShowTotals" value="False" type="Boolean"/><column name="" property="TableStyle.Name" value="TableStyleMedium15" type="String"/><column name="" property="ShowTableStyleColumnStripes" value="False" type="Boolean"/><column name="" property="ShowTableStyleFirstColumn" value="False" type="Boolean"/><column name="" property="ShowShowTableStyleLastColumn" value="False" type="Boolean"/><column name="" property="ShowTableStyleRowStripes" value="False" type="Boolean"/><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean"/><column name="_RowNum" property="Address" value="$B$4" type="String"/><column name="_RowNum" property="NumberFormat" value="General" type="String"/><column name="ID" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="ID" property="Address" value="$C$4" type="String"/><column name="ID" property="ColumnWidth" value="4.43" type="Double"/><column name="ID" property="NumberFormat" value="General" type="String"/><column name="ID" property="Validation.Type" value="1" type="Double"/><column name="ID" property="Validation.Operator" value="1" type="Double"/><column name="ID" property="Validation.Formula1" value="-2147483648" type="String"/><column name="ID" property="Validation.Formula2" value="2147483647" type="String"/><column name="ID" property="Validation.AlertStyle" value="1" type="Double"/><column name="ID" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="ID" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="ID" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="ID" property="Validation.ErrorMessage" value="The column requires values of the int datatype." type="String"/><column name="ID" property="Validation.ShowInput" value="True" type="Boolean"/><column name="ID" property="Validation.ShowError" value="True" type="Boolean"/><column name="TABLE_SCHEMA" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="TABLE_SCHEMA" property="Address" value="$D$4" type="String"/><column name="TABLE_SCHEMA" property="ColumnWidth" value="16.57" type="Double"/><column name="TABLE_SCHEMA" property="NumberFormat" value="General" type="String"/><column name="TABLE_SCHEMA" property="Validation.Type" value="6" type="Double"/><column name="TABLE_SCHEMA" property="Validation.Operator" value="8" type="Double"/><column name="TABLE_SCHEMA" property="Validation.Formula1" value="128" type="String"/><column name="TABLE_SCHEMA" property="Validation.AlertStyle" value="1" type="Double"/><column name="TABLE_SCHEMA" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="TABLE_SCHEMA" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="TABLE_SCHEMA" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="TABLE_SCHEMA" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String"/><column name="TABLE_SCHEMA" property="Validation.ShowInput" value="True" type="Boolean"/><column name="TABLE_SCHEMA" property="Validation.ShowError" value="True" type="Boolean"/><column name="TABLE_NAME" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="TABLE_NAME" property="Address" value="$E$4" type="String"/><column name="TABLE_NAME" property="ColumnWidth" value="14.43" type="Double"/><column name="TABLE_NAME" property="NumberFormat" value="General" type="String"/><column name="TABLE_NAME" property="Validation.Type" value="6" type="Double"/><column name="TABLE_NAME" property="Validation.Operator" value="8" type="Double"/><column name="TABLE_NAME" property="Validation.Formula1" value="128" type="String"/><column name="TABLE_NAME" property="Validation.AlertStyle" value="1" type="Double"/><column name="TABLE_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="TABLE_NAME" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="TABLE_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="TABLE_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String"/><column name="TABLE_NAME" property="Validation.ShowInput" value="True" type="Boolean"/><column name="TABLE_NAME" property="Validation.ShowError" value="True" type="Boolean"/><column name="COLUMN_NAME" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="COLUMN_NAME" property="Address" value="$F$4" type="String"/><column name="COLUMN_NAME" property="ColumnWidth" value="17.43" type="Double"/><column name="COLUMN_NAME" property="NumberFormat" value="General" type="String"/><column name="COLUMN_NAME" property="Validation.Type" value="6" type="Double"/><column name="COLUMN_NAME" property="Validation.Operator" value="8" type="Double"/><column name="COLUMN_NAME" property="Validation.Formula1" value="128" type="String"/><column name="COLUMN_NAME" property="Validation.AlertStyle" value="1" type="Double"/><column name="COLUMN_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="COLUMN_NAME" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="COLUMN_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="COLUMN_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String"/><column name="COLUMN_NAME" property="Validation.ShowInput" value="True" type="Boolean"/><column name="COLUMN_NAME" property="Validation.ShowError" value="True" type="Boolean"/><column name="EVENT_NAME" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="EVENT_NAME" property="Address" value="$G$4" type="String"/><column name="EVENT_NAME" property="ColumnWidth" value="15" type="Double"/><column name="EVENT_NAME" property="NumberFormat" value="General" type="String"/><column name="EVENT_NAME" property="Validation.Type" value="3" type="Double"/><column name="EVENT_NAME" property="Validation.Operator" value="1" type="Double"/><column name="EVENT_NAME" property="Validation.Formula1" value="Actions;Change;ContextMenu;DoubleClick;SelectionChange;ConvertFormulas;DoNotConvertFormulas;DoNotSelect;DoNotSave;DoNotChange;ProtectRows;Formula;FormulaValue;ValidationList;SelectionList" type="String"/><column name="EVENT_NAME" property="Validation.Formula2" value="" type="String"/><column name="EVENT_NAME" property="Validation.AlertStyle" value="1" type="Double"/><column name="EVENT_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="EVENT_NAME" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="EVENT_NAME" property="Validation.ShowInput" value="True" type="Boolean"/><column name="EVENT_NAME" property="Validation.ShowError" value="True" type="Boolean"/><column name="HANDLER_SCHEMA" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="HANDLER_SCHEMA" property="Address" value="$H$4" type="String"/><column name="HANDLER_SCHEMA" property="ColumnWidth" value="19.71" type="Double"/><column name="HANDLER_SCHEMA" property="NumberFormat" value="General" type="String"/><column name="HANDLER_SCHEMA" property="Validation.Type" value="6" type="Double"/><column name="HANDLER_SCHEMA" property="Validation.Operator" value="8" type="Double"/><column name="HANDLER_SCHEMA" property="Validation.Formula1" value="128" type="String"/><column name="HANDLER_SCHEMA" property="Validation.AlertStyle" value="1" type="Double"/><column name="HANDLER_SCHEMA" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="HANDLER_SCHEMA" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="HANDLER_SCHEMA" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="HANDLER_SCHEMA" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String"/><column name="HANDLER_SCHEMA" property="Validation.ShowInput" value="True" type="Boolean"/><column name="HANDLER_SCHEMA" property="Validation.ShowError" value="True" type="Boolean"/><column name="HANDLER_NAME" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="HANDLER_NAME" property="Address" value="$I$4" type="String"/><column name="HANDLER_NAME" property="ColumnWidth" value="17.57" type="Double"/><column name="HANDLER_NAME" property="NumberFormat" value="General" type="String"/><column name="HANDLER_NAME" property="Validation.Type" value="6" type="Double"/><column name="HANDLER_NAME" property="Validation.Operator" value="8" type="Double"/><column name="HANDLER_NAME" property="Validation.Formula1" value="128" type="String"/><column name="HANDLER_NAME" property="Validation.AlertStyle" value="1" type="Double"/><column name="HANDLER_NAME" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="HANDLER_NAME" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="HANDLER_NAME" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="HANDLER_NAME" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String"/><column name="HANDLER_NAME" property="Validation.ShowInput" value="True" type="Boolean"/><column name="HANDLER_NAME" property="Validation.ShowError" value="True" type="Boolean"/><column name="HANDLER_TYPE" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="HANDLER_TYPE" property="Address" value="$J$4" type="String"/><column name="HANDLER_TYPE" property="ColumnWidth" value="16.29" type="Double"/><column name="HANDLER_TYPE" property="NumberFormat" value="General" type="String"/><column name="HANDLER_TYPE" property="Validation.Type" value="3" type="Double"/><column name="HANDLER_TYPE" property="Validation.Operator" value="1" type="Double"/><column name="HANDLER_TYPE" property="Validation.Formula1" value="TABLE;VIEW;PROCEDURE;FUNCTION;CODE;HTTP;TEXT;MACRO;CMD;VALUES;RANGE;REFRESH;MENUSEPARATOR" type="String"/><column name="HANDLER_TYPE" property="Validation.Formula2" value="" type="String"/><column name="HANDLER_TYPE" property="Validation.AlertStyle" value="1" type="Double"/><column name="HANDLER_TYPE" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="HANDLER_TYPE" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="HANDLER_TYPE" property="Validation.ShowInput" value="True" type="Boolean"/><column name="HANDLER_TYPE" property="Validation.ShowError" value="True" type="Boolean"/><column name="HANDLER_CODE" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="HANDLER_CODE" property="Address" value="$K$4" type="String"/><column name="HANDLER_CODE" property="ColumnWidth" value="30" type="Double"/><column name="HANDLER_CODE" property="NumberFormat" value="General" type="String"/><column name="TARGET_WORKSHEET" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="TARGET_WORKSHEET" property="Address" value="$L$4" type="String"/><column name="TARGET_WORKSHEET" property="ColumnWidth" value="21.71" type="Double"/><column name="TARGET_WORKSHEET" property="NumberFormat" value="General" type="String"/><column name="TARGET_WORKSHEET" property="Validation.Type" value="6" type="Double"/><column name="TARGET_WORKSHEET" property="Validation.Operator" value="8" type="Double"/><column name="TARGET_WORKSHEET" property="Validation.Formula1" value="128" type="String"/><column name="TARGET_WORKSHEET" property="Validation.AlertStyle" value="1" type="Double"/><column name="TARGET_WORKSHEET" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="TARGET_WORKSHEET" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="TARGET_WORKSHEET" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="TARGET_WORKSHEET" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(128) datatype." type="String"/><column name="TARGET_WORKSHEET" property="Validation.ShowInput" value="True" type="Boolean"/><column name="TARGET_WORKSHEET" property="Validation.ShowError" value="True" type="Boolean"/><column name="MENU_ORDER" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="MENU_ORDER" property="Address" value="$M$4" type="String"/><column name="MENU_ORDER" property="ColumnWidth" value="15.43" type="Double"/><column name="MENU_ORDER" property="NumberFormat" value="General" type="String"/><column name="MENU_ORDER" property="Validation.Type" value="1" type="Double"/><column name="MENU_ORDER" property="Validation.Operator" value="1" type="Double"/><column name="MENU_ORDER" property="Validation.Formula1" value="-2147483648" type="String"/><column name="MENU_ORDER" property="Validation.Formula2" value="2147483647" type="String"/><column name="MENU_ORDER" property="Validation.AlertStyle" value="1" type="Double"/><column name="MENU_ORDER" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="MENU_ORDER" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="MENU_ORDER" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="MENU_ORDER" property="Validation.ErrorMessage" value="The column requires values of the int datatype." type="String"/><column name="MENU_ORDER" property="Validation.ShowInput" value="True" type="Boolean"/><column name="MENU_ORDER" property="Validation.ShowError" value="True" type="Boolean"/><column name="EDIT_PARAMETERS" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="EDIT_PARAMETERS" property="Address" value="$N$4" type="String"/><column name="EDIT_PARAMETERS" property="ColumnWidth" value="19.57" type="Double"/><column name="EDIT_PARAMETERS" property="NumberFormat" value="General" type="String"/><column name="IS_ACTIVE" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="IS_ACTIVE" property="Address" value="$O$4" type="String"/><column name="IS_ACTIVE" property="ColumnWidth" value="11.43" type="Double"/><column name="IS_ACTIVE" property="NumberFormat" value="General" type="String"/><column name="TABLE_SCHEMA" property="FormatConditions(1).AppliesTo.Address" value="$D$4:$D$16" type="String"/><column name="TABLE_SCHEMA" property="FormatConditions(1).Type" value="2" type="Double"/><column name="TABLE_SCHEMA" property="FormatConditions(1).Priority" value="14" type="Double"/><column name="TABLE_SCHEMA" property="FormatConditions(1).Formula1" value="=ISBLANK(D4)" type="String"/><column name="TABLE_SCHEMA" property="FormatConditions(1).Interior.Color" value="65535" type="Double"/><column name="TABLE_SCHEMA" property="FormatConditions(1).Interior.ThemeColor" value="0" type="Double"/><column name="TABLE_SCHEMA" property="FormatConditions(1).Interior.TintAndShade" value="0" type="Double"/><column name="" property="ActiveWindow.DisplayGridlines" value="False" type="Boolean"/><column name="" property="ActiveWindow.FreezePanes" value="True" type="Boolean"/><column name="" property="ActiveWindow.Split" value="True" type="Boolean"/><column name="" property="ActiveWindow.SplitRow" value="0" type="Double"/><column name="" property="ActiveWindow.SplitColumn" value="-2" type="Double"/><column name="" property="PageSetup.Orientation" value="1" type="Double"/><column name="" property="PageSetup.FitToPagesWide" value="1" type="Double"/><column name="" property="PageSetup.FitToPagesTall" value="1" type="Double"/><column name="" property="PageSetup.PaperSize" value="1" type="Double"/></columnFormats></table>');
INSERT INTO [dbo69].[TableFormats] ([TABLE_SCHEMA], [TABLE_NAME], [TABLE_EXCEL_FORMAT_XML]) VALUES (N'dbo69', N'Companies', '<table name="dbo69.Companies"><columnFormats><column name="" property="ListObjectName" value="Sheet4_Table1" type="String"/><column name="" property="ShowTotals" value="False" type="Boolean"/><column name="" property="TableStyle.Name" value="TableStyleMedium15" type="String"/><column name="" property="ShowTableStyleColumnStripes" value="False" type="Boolean"/><column name="" property="ShowTableStyleFirstColumn" value="False" type="Boolean"/><column name="" property="ShowShowTableStyleLastColumn" value="False" type="Boolean"/><column name="" property="ShowTableStyleRowStripes" value="False" type="Boolean"/><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean"/><column name="_RowNum" property="Address" value="$B$4" type="String"/><column name="_RowNum" property="NumberFormat" value="General" type="String"/><column name="Company" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Company" property="Address" value="$C$4" type="String"/><column name="Company" property="ColumnWidth" value="15.57" type="Double"/><column name="Company" property="NumberFormat" value="General" type="String"/><column name="Company" property="Validation.Type" value="6" type="Double"/><column name="Company" property="Validation.Operator" value="8" type="Double"/><column name="Company" property="Validation.Formula1" value="255" type="String"/><column name="Company" property="Validation.AlertStyle" value="1" type="Double"/><column name="Company" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="Company" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="Company" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="Company" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(255) datatype." type="String"/><column name="Company" property="Validation.ShowInput" value="True" type="Boolean"/><column name="Company" property="Validation.ShowError" value="True" type="Boolean"/><column name="LastModified" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="LastModified" property="Address" value="$D$4" type="String"/><column name="LastModified" property="ColumnWidth" value="14.29" type="Double"/><column name="LastModified" property="NumberFormat" value="m/d/yyyy" type="String"/><column name="LastModified" property="Validation.Type" value="6" type="Double"/><column name="LastModified" property="Validation.Operator" value="8" type="Double"/><column name="LastModified" property="Validation.Formula1" value="255" type="String"/><column name="LastModified" property="Validation.AlertStyle" value="1" type="Double"/><column name="LastModified" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="LastModified" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="LastModified" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="LastModified" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(255) datatype." type="String"/><column name="LastModified" property="Validation.ShowInput" value="True" type="Boolean"/><column name="LastModified" property="Validation.ShowError" value="True" type="Boolean"/><column name="UserName" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="UserName" property="Address" value="$E$4" type="String"/><column name="UserName" property="ColumnWidth" value="12" type="Double"/><column name="UserName" property="NumberFormat" value="General" type="String"/><column name="UserName" property="Validation.Type" value="6" type="Double"/><column name="UserName" property="Validation.Operator" value="8" type="Double"/><column name="UserName" property="Validation.Formula1" value="255" type="String"/><column name="UserName" property="Validation.AlertStyle" value="1" type="Double"/><column name="UserName" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="UserName" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="UserName" property="Validation.ErrorTitle" value="Datatype Control" type="String"/><column name="UserName" property="Validation.ErrorMessage" value="The column requires values of the nvarchar(255) datatype." type="String"/><column name="UserName" property="Validation.ShowInput" value="True" type="Boolean"/><column name="UserName" property="Validation.ShowError" value="True" type="Boolean"/><column name="Company" property="FormatConditions(1).AppliesTo.Address" value="$C$4:$C$11" type="String"/><column name="Company" property="FormatConditions(1).Type" value="2" type="Double"/><column name="Company" property="FormatConditions(1).Priority" value="1" type="Double"/><column name="Company" property="FormatConditions(1).Formula1" value="=ISBLANK(C4)" type="String"/><column name="Company" property="FormatConditions(1).Interior.Color" value="65535" type="Double"/><column name="Company" property="FormatConditions(1).Interior.ThemeColor" value="0" type="Double"/><column name="Company" property="FormatConditions(1).Interior.TintAndShade" value="0" type="Double"/><column name="" property="ActiveWindow.DisplayGridlines" value="False" type="Boolean"/><column name="" property="ActiveWindow.FreezePanes" value="True" type="Boolean"/><column name="" property="ActiveWindow.Split" value="True" type="Boolean"/><column name="" property="ActiveWindow.SplitRow" value="0" type="Double"/><column name="" property="ActiveWindow.SplitColumn" value="-2" type="Double"/><column name="" property="PageSetup.Orientation" value="1" type="Double"/><column name="" property="PageSetup.Zoom" value="100" type="Double"/></columnFormats></table>');
INSERT INTO [dbo69].[TableFormats] ([TABLE_SCHEMA], [TABLE_NAME], [TABLE_EXCEL_FORMAT_XML]) VALUES (N'dbo69', N'Payments', '<table name="dbo69.Payments"><columnFormats><column name="" property="ListObjectName" value="Sheet6_Table1" type="String"/><column name="" property="ShowTotals" value="False" type="Boolean"/><column name="" property="TableStyle.Name" value="TableStyleMedium15" type="String"/><column name="" property="ShowTableStyleColumnStripes" value="False" type="Boolean"/><column name="" property="ShowTableStyleFirstColumn" value="False" type="Boolean"/><column name="" property="ShowShowTableStyleLastColumn" value="False" type="Boolean"/><column name="" property="ShowTableStyleRowStripes" value="False" type="Boolean"/><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean"/><column name="_RowNum" property="Address" value="$B$4" type="String"/><column name="_RowNum" property="NumberFormat" value="General" type="String"/><column name="ID" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="ID" property="Address" value="$C$4" type="String"/><column name="ID" property="ColumnWidth" value="4.43" type="Double"/><column name="ID" property="NumberFormat" value="General" type="String"/><column name="Date" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Date" property="Address" value="$D$4" type="String"/><column name="Date" property="ColumnWidth" value="10.57" type="Double"/><column name="Date" property="NumberFormat" value="m/d/yyyy" type="String"/><column name="Date" property="BorderxlEdgeRight.LineStyle" value="1" type="Double"/><column name="Date" property="BorderxlEdgeRight.Weight" value="2" type="Double"/><column name="Date" property="BorderxlEdgeRight.Color" value="0" type="Double"/><column name="Date" property="BorderxlEdgeRight.ThemeColor" value="2" type="Double"/><column name="Date" property="BorderxlEdgeRight.TintAndShade" value="0" type="Double"/><column name="Sum" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Sum" property="Address" value="$E$4" type="String"/><column name="Sum" property="ColumnWidth" value="12.14" type="Double"/><column name="Sum" property="NumberFormat" value="#,##0.00_ ;[Red]-#,##0.00 " type="String"/><column name="Sum" property="BorderxlEdgeLeft.LineStyle" value="1" type="Double"/><column name="Sum" property="BorderxlEdgeLeft.Weight" value="2" type="Double"/><column name="Sum" property="BorderxlEdgeLeft.Color" value="0" type="Double"/><column name="Sum" property="BorderxlEdgeLeft.ThemeColor" value="2" type="Double"/><column name="Sum" property="BorderxlEdgeLeft.TintAndShade" value="0" type="Double"/><column name="Sum" property="BorderxlEdgeRight.LineStyle" value="1" type="Double"/><column name="Sum" property="BorderxlEdgeRight.Weight" value="2" type="Double"/><column name="Sum" property="BorderxlEdgeRight.Color" value="0" type="Double"/><column name="Sum" property="BorderxlEdgeRight.ThemeColor" value="2" type="Double"/><column name="Sum" property="BorderxlEdgeRight.TintAndShade" value="0" type="Double"/><column name="Account" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Account" property="Address" value="$F$4" type="String"/><column name="Account" property="ColumnWidth" value="10" type="Double"/><column name="Account" property="NumberFormat" value="General" type="String"/><column name="Account" property="BorderxlEdgeLeft.LineStyle" value="1" type="Double"/><column name="Account" property="BorderxlEdgeLeft.Weight" value="2" type="Double"/><column name="Account" property="BorderxlEdgeLeft.Color" value="0" type="Double"/><column name="Account" property="BorderxlEdgeLeft.ThemeColor" value="2" type="Double"/><column name="Account" property="BorderxlEdgeLeft.TintAndShade" value="0" type="Double"/><column name="Account" property="BorderxlEdgeRight.LineStyle" value="1" type="Double"/><column name="Account" property="BorderxlEdgeRight.Weight" value="2" type="Double"/><column name="Account" property="BorderxlEdgeRight.Color" value="0" type="Double"/><column name="Account" property="BorderxlEdgeRight.ThemeColor" value="2" type="Double"/><column name="Account" property="BorderxlEdgeRight.TintAndShade" value="0" type="Double"/><column name="Account" property="Validation.Type" value="3" type="Double"/><column name="Account" property="Validation.Operator" value="1" type="Double"/><column name="Account" property="Validation.Formula1" value="My Bank" type="String"/><column name="Account" property="Validation.Formula2" value="" type="String"/><column name="Account" property="Validation.AlertStyle" value="1" type="Double"/><column name="Account" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="Account" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="Account" property="Validation.ShowInput" value="True" type="Boolean"/><column name="Account" property="Validation.ShowError" value="True" type="Boolean"/><column name="Company" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Company" property="Address" value="$G$4" type="String"/><column name="Company" property="ColumnWidth" value="15.71" type="Double"/><column name="Company" property="NumberFormat" value="General" type="String"/><column name="Company" property="BorderxlEdgeLeft.LineStyle" value="1" type="Double"/><column name="Company" property="BorderxlEdgeLeft.Weight" value="2" type="Double"/><column name="Company" property="BorderxlEdgeLeft.Color" value="0" type="Double"/><column name="Company" property="BorderxlEdgeLeft.ThemeColor" value="2" type="Double"/><column name="Company" property="BorderxlEdgeLeft.TintAndShade" value="0" type="Double"/><column name="Company" property="BorderxlEdgeRight.LineStyle" value="1" type="Double"/><column name="Company" property="BorderxlEdgeRight.Weight" value="2" type="Double"/><column name="Company" property="BorderxlEdgeRight.Color" value="0" type="Double"/><column name="Company" property="BorderxlEdgeRight.ThemeColor" value="2" type="Double"/><column name="Company" property="BorderxlEdgeRight.TintAndShade" value="0" type="Double"/><column name="Company" property="Validation.Type" value="3" type="Double"/><column name="Company" property="Validation.Operator" value="1" type="Double"/><column name="Company" property="Validation.Formula1" value="=INDIRECT(&quot;vl_dbo69_Companies[Company]&quot;)" type="String"/><column name="Company" property="Validation.Formula2" value="" type="String"/><column name="Company" property="Validation.AlertStyle" value="1" type="Double"/><column name="Company" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="Company" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="Company" property="Validation.ShowInput" value="True" type="Boolean"/><column name="Company" property="Validation.ShowError" value="True" type="Boolean"/><column name="Item" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Item" property="Address" value="$H$4" type="String"/><column name="Item" property="ColumnWidth" value="11.43" type="Double"/><column name="Item" property="NumberFormat" value="General" type="String"/><column name="Item" property="BorderxlEdgeLeft.LineStyle" value="1" type="Double"/><column name="Item" property="BorderxlEdgeLeft.Weight" value="2" type="Double"/><column name="Item" property="BorderxlEdgeLeft.Color" value="0" type="Double"/><column name="Item" property="BorderxlEdgeLeft.ThemeColor" value="2" type="Double"/><column name="Item" property="BorderxlEdgeLeft.TintAndShade" value="0" type="Double"/><column name="Item" property="BorderxlEdgeRight.LineStyle" value="1" type="Double"/><column name="Item" property="BorderxlEdgeRight.Weight" value="2" type="Double"/><column name="Item" property="BorderxlEdgeRight.Color" value="0" type="Double"/><column name="Item" property="BorderxlEdgeRight.ThemeColor" value="2" type="Double"/><column name="Item" property="BorderxlEdgeRight.TintAndShade" value="0" type="Double"/><column name="Item" property="Validation.Type" value="3" type="Double"/><column name="Item" property="Validation.Operator" value="1" type="Double"/><column name="Item" property="Validation.Formula1" value="Revenue;Expenses;Payroll;Taxes" type="String"/><column name="Item" property="Validation.Formula2" value="" type="String"/><column name="Item" property="Validation.AlertStyle" value="1" type="Double"/><column name="Item" property="Validation.IgnoreBlank" value="True" type="Boolean"/><column name="Item" property="Validation.InCellDropdown" value="True" type="Boolean"/><column name="Item" property="Validation.ShowInput" value="True" type="Boolean"/><column name="Item" property="Validation.ShowError" value="True" type="Boolean"/><column name="Comment" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Comment" property="Address" value="$I$4" type="String"/><column name="Comment" property="ColumnWidth" value="11.29" type="Double"/><column name="Comment" property="NumberFormat" value="General" type="String"/><column name="Comment" property="BorderxlEdgeLeft.LineStyle" value="1" type="Double"/><column name="Comment" property="BorderxlEdgeLeft.Weight" value="2" type="Double"/><column name="Comment" property="BorderxlEdgeLeft.Color" value="0" type="Double"/><column name="Comment" property="BorderxlEdgeLeft.ThemeColor" value="2" type="Double"/><column name="Comment" property="BorderxlEdgeLeft.TintAndShade" value="0" type="Double"/><column name="" property="ActiveWindow.DisplayGridlines" value="False" type="Boolean"/><column name="" property="ActiveWindow.FreezePanes" value="True" type="Boolean"/><column name="" property="ActiveWindow.Split" value="True" type="Boolean"/><column name="" property="ActiveWindow.SplitRow" value="0" type="Double"/><column name="" property="ActiveWindow.SplitColumn" value="-2" type="Double"/><column name="" property="PageSetup.Orientation" value="1" type="Double"/><column name="" property="PageSetup.FitToPagesWide" value="1" type="Double"/><column name="" property="PageSetup.FitToPagesTall" value="1" type="Double"/><column name="" property="PageSetup.PaperSize" value="1" type="Double"/></columnFormats><views><view name="All Payments"><column name="" property="ListObjectName" value="Sheet6_Table1" type="String"/><column name="" property="ShowTotals" value="False" type="Boolean"/><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean"/><column name="ID" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Date" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Sum" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Account" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Company" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Item" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Comment" property="EntireColumn.Hidden" value="False" type="Boolean"/></view><view name="Incomes"><column name="" property="ListObjectName" value="Sheet6_Table1" type="String"/><column name="" property="ShowTotals" value="False" type="Boolean"/><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean"/><column name="ID" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Date" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Sum" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Account" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Company" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Item" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Comment" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Sum" property="AutoFilter.Criteria1" value="&gt;0" type="String"/></view><view name="Expenses"><column name="" property="ListObjectName" value="Sheet6_Table1" type="String"/><column name="" property="ShowTotals" value="False" type="Boolean"/><column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean"/><column name="ID" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Date" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Sum" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Account" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Company" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Item" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Comment" property="EntireColumn.Hidden" value="False" type="Boolean"/><column name="Sum" property="AutoFilter.Criteria1" value="&lt;0" type="String"/></view></views></table>');
GO


print N'The application has been installed';
GO
